﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GroupHeaderArrangement
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

			this.SetupGrid();
			this.SetupGroups();
        }

		/// <summary>
		/// Setup RowLayoutStyle.GroupLayout Group-Headrers
		/// </summary>
		private void SetupGroups()
		{
			UltraGridBand band = ultraGrid1.DisplayLayout.Bands[0];

			// column width for day columns
			int colWidth = 3;

			// LABEL GROUPS ----------------------------------------------------------------

			// group label monathname
			UltraGridGroup groupMonthLabel = band.Groups.Add( "GroupMonthLabel" );
			groupMonthLabel.Header.Caption = "GroupMonthLabel";
			groupMonthLabel.RowLayoutGroupInfo.OriginX = 0;
			groupMonthLabel.RowLayoutGroupInfo.OriginY = 0;
			groupMonthLabel.RowLayoutGroupInfo.SpanX = 1;
			groupMonthLabel.RowLayoutGroupInfo.SpanY = 2;

			// group label week-number
			UltraGridGroup groupWeekLabel = band.Groups.Add( "WeekLabel" );
			groupWeekLabel.Header.Caption = "GroupWeekLabel";
			groupWeekLabel.RowLayoutGroupInfo.OriginX = 0;
			groupWeekLabel.RowLayoutGroupInfo.OriginY = 2;
			groupWeekLabel.RowLayoutGroupInfo.SpanX = 1;
			groupWeekLabel.RowLayoutGroupInfo.SpanY = 2;

			// MONTH GROUPS ----------------------------------------------------------------

			// group january
			UltraGridGroup groupJanuary = band.Groups.Add( "January" );
			groupJanuary.Header.Caption = "January";
			// - starts after label group
			groupJanuary.RowLayoutGroupInfo.OriginX = 1;
			// - first header row
			groupJanuary.RowLayoutGroupInfo.OriginY = 0;
			// - spans for 31 columns = days
			groupJanuary.RowLayoutGroupInfo.SpanX = 31;
			// - first header row spans of 2 
			groupJanuary.RowLayoutGroupInfo.SpanY = 2;
			groupJanuary.RowLayoutGroupInfo.MinimumCellSize = new Size( 1, 0 );

			// group february
			UltraGridGroup groupFebruary = band.Groups.Add( "February" );
			groupFebruary.Header.Caption = "February";
			// - starts after january
			groupFebruary.RowLayoutGroupInfo.OriginX = 1 + 31;
			groupFebruary.RowLayoutGroupInfo.OriginY = 0;
			groupFebruary.RowLayoutGroupInfo.SpanX = 28;
			groupFebruary.RowLayoutGroupInfo.SpanY = 2;
			groupFebruary.RowLayoutGroupInfo.MinimumCellSize = new Size( 1, 0 );

			// group march
			UltraGridGroup groupMarch = band.Groups.Add( "March" );
			groupMarch.Header.Caption = "March";
			groupMarch.RowLayoutGroupInfo.OriginX = 1 + 31 + 28;
			groupMarch.RowLayoutGroupInfo.OriginY = 0;
			groupMarch.RowLayoutGroupInfo.SpanX = 31;
			groupMarch.RowLayoutGroupInfo.SpanY = 2;
			groupMarch.RowLayoutGroupInfo.MinimumCellSize = new Size( 1, 0 );

			// WEEK GROUPS ------------------------------------------------------------------
			// - add first week group for uncomplete week of 4 days
			UltraGridGroup groupWeek1 = band.Groups.Add( "Week1" );
			groupWeek1.Header.Caption = "1";
			groupWeek1.Header.Appearance.TextHAlign = Infragistics.Win.HAlign.Left;
			// - starts after label group
			groupWeek1.RowLayoutGroupInfo.OriginX = 1;
			// - second header starts below frist header row of 2 
			groupWeek1.RowLayoutGroupInfo.OriginY = 2;
			// - spans 4 days
			groupWeek1.RowLayoutGroupInfo.SpanX = 4;
			// - two units  
			groupWeek1.RowLayoutGroupInfo.SpanY = 2;
			groupWeek1.RowLayoutGroupInfo.MinimumLabelSize = new Size( 1, 0 );
			groupWeek1.RowLayoutGroupInfo.MinimumCellSize = new Size( 1, 0 );
			groupWeek1.RowLayoutGroupInfo.PreferredCellSize = new Size( colWidth * groupWeek1.RowLayoutGroupInfo.SpanX, 0 );
			groupWeek1.RowLayoutGroupInfo.PreferredLabelSize = new Size( colWidth, 0 );

			for ( int weekNo = 2; weekNo < 14; weekNo++ )
			{
				UltraGridGroup groupWeek = band.Groups.Add( string.Format( "Week{0}", weekNo ) );
				groupWeek.Header.Caption = string.Format( "{0}", weekNo );
				groupWeek.Header.Appearance.TextHAlign = Infragistics.Win.HAlign.Left;
				groupWeek.RowLayoutGroupInfo.OriginX = 1 + 4 + ( weekNo - 2 ) * 7;
				groupWeek.RowLayoutGroupInfo.OriginY = 2;
				groupWeek.RowLayoutGroupInfo.SpanX = 7;
				groupWeek.RowLayoutGroupInfo.SpanY = 2;
				groupWeek.RowLayoutGroupInfo.MinimumLabelSize = new Size( 1, 0 );
				groupWeek.RowLayoutGroupInfo.MinimumCellSize = new Size( 1, 0 );
				groupWeek.RowLayoutGroupInfo.PreferredCellSize = new Size( colWidth * groupWeek.RowLayoutGroupInfo.SpanX, 0 );
				groupWeek.RowLayoutGroupInfo.PreferredLabelSize = new Size( colWidth, 0 );
			}

			UltraGridGroup groupWeek14 = band.Groups.Add( "Week14" );
			groupWeek14.Header.Caption = "14";
			groupWeek14.Header.Appearance.TextHAlign = Infragistics.Win.HAlign.Left;
			groupWeek14.RowLayoutGroupInfo.OriginX = 1 + 4 + ( 14 - 2 ) * 7;
			groupWeek14.RowLayoutGroupInfo.OriginY = 2;
			groupWeek14.RowLayoutGroupInfo.SpanX = 2;
			groupWeek14.RowLayoutGroupInfo.SpanY = 2;
			groupWeek14.RowLayoutGroupInfo.MinimumLabelSize = new Size( 1, 0 );
			groupWeek14.RowLayoutGroupInfo.MinimumCellSize = new Size( 1, 0 );
			groupWeek14.RowLayoutGroupInfo.PreferredCellSize = new Size( colWidth * groupWeek14.RowLayoutGroupInfo.SpanX, 0 );
			groupWeek14.RowLayoutGroupInfo.PreferredLabelSize = new Size( colWidth, 0 );

			// add columns to the groups
			DateTime firstJanuary = new DateTime( 2015, 1, 1 );
			DateTime firstFebruary = new DateTime( 2015, 2, 1 );
			DateTime firstMarch = new DateTime( 2015, 3, 1 );

			foreach ( UltraGridColumn col in band.Columns )
			{
				// Spalte Organisation
				if ( col.Index == 0 )
				{
					col.Width = 120;

					col.RowLayoutColumnInfo.ParentGroup = groupMonthLabel;
					col.RowLayoutColumnInfo.OriginX = 0;
					col.RowLayoutColumnInfo.OriginY = 0;
					col.RowLayoutColumnInfo.SpanX = 1;
					col.RowLayoutColumnInfo.SpanY = 2;
				}

				// Tagesspalten
				else
				{
					DateTime colDate = DateTime.Parse( col.Key );

					col.RowLayoutColumnInfo.MinimumCellSize = new Size( 1, 0 );
					col.RowLayoutColumnInfo.MinimumLabelSize = new Size( 1, 0 );
					col.RowLayoutColumnInfo.PreferredCellSize = new Size( colWidth, 0 );
					col.RowLayoutColumnInfo.PreferredLabelSize = new Size( colWidth, 0 );

					if ( colDate.Month == 1 )
					{
						col.RowLayoutColumnInfo.ParentGroup = groupJanuary;
						col.RowLayoutColumnInfo.OriginX = ( colDate - firstJanuary ).Days;
						col.RowLayoutColumnInfo.OriginY = 0;
						col.RowLayoutColumnInfo.SpanX = 1;
						col.RowLayoutColumnInfo.SpanY = 2;
						col.CellAppearance.BackColor = Color.LightBlue;
					}
					else if ( colDate.Month == 2 )
					{
						col.RowLayoutColumnInfo.ParentGroup = groupFebruary;
						col.RowLayoutColumnInfo.OriginX = ( colDate - firstFebruary ).Days;
						col.RowLayoutColumnInfo.OriginY = 0;
						col.RowLayoutColumnInfo.SpanX = 1;
						col.RowLayoutColumnInfo.SpanY = 2;
						col.CellAppearance.BackColor = colDate.Day > 8 && colDate.Day <= 15 ? Color.LightPink : Color.Tomato;
					}
					else if ( colDate.Month == 3 )
					{
						col.RowLayoutColumnInfo.ParentGroup = groupMarch;
						col.RowLayoutColumnInfo.OriginX = ( colDate - firstMarch ).Days;
						col.RowLayoutColumnInfo.OriginY = 0;
						col.RowLayoutColumnInfo.SpanX = 1;
						col.RowLayoutColumnInfo.SpanY = 2;
						col.CellAppearance.BackColor = Color.LemonChiffon;
					}
				}
			}
		}

		private void SetupGrid()
		{
			DateTime start = new DateTime( 2015, 1, 1 );
			DateTime end = new DateTime( 2015, 3, 31 );

			DataTable dt = new DataTable();
			dt.Columns.Add( "Name", typeof( string ) );

			for ( DateTime date = start; date <= end; date = date.AddDays( 1 ) )
				dt.Columns.Add( date.ToShortDateString(), typeof( string ) );

			DataRow row = dt.Rows.Add();
			row[0] = "Administration";
			row = dt.Rows.Add();
			row[0] = "Benson George";
			row = dt.Rows.Add();
			row[0] = "Chanson d'Amour";
			row = dt.Rows.Add();
			row[0] = "Flip Jerry";

			ultraGrid1.DataSource = dt;
			UltraGridBand band = ultraGrid1.DisplayLayout.Bands[0];
			band.RowLayoutStyle = RowLayoutStyle.GroupLayout;
			band.ColHeadersVisible = false;
			band.Override.DefaultColWidth = 1;
		}

		private void ultraGrid1_InitializeLayout( object sender, InitializeLayoutEventArgs e )
		{
			e.Layout.AutoFitStyle = AutoFitStyle.None;

			e.Layout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
			e.Layout.Override.AllowColSizing = AllowColSizing.None;
			e.Layout.Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.False;
			e.Layout.Override.ColumnAutoSizeMode = ColumnAutoSizeMode.None;

			e.Layout.Override.RowSizing = RowSizing.Fixed;
			e.Layout.Override.RowSizingArea = RowSizingArea.EntireRow;
			e.Layout.Override.DefaultRowHeight = 22;
			e.Layout.Override.MinRowHeight = 1;


		}

    }
}
